/*
 * Copyright 2002-2018 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.webauthn4j.converter.jackson.deserializer;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.deser.std.StdDeserializer;
import com.webauthn4j.data.extension.client.UnknownExtensionClientInput;

import java.io.IOException;
import java.io.Serializable;

public class UnknownExtensionClientInputDeserializer extends StdDeserializer<UnknownExtensionClientInput> {

    public UnknownExtensionClientInputDeserializer() {
        super(UnknownExtensionClientInput.class);
    }

    @Override
    public UnknownExtensionClientInput deserialize(JsonParser p, DeserializationContext ctxt) throws IOException {
        Serializable value = ctxt.readValue(p, Serializable.class);
        return new UnknownExtensionClientInput(p.getCurrentName(), value);
    }
}
